unit main;
interface
uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ComCtrls, ExtCtrls,Dialogs, Menus;

type
   matrix3x3=array [1..3,1..3] of real;
   points=array [1..3] of TPoint;
   coords=array [1..100] of TPoint;

   Tcalculate = class(TForm) GroupBox1: TGroupBox;
    Memo1: TMemo;
    SaveDialog1: TSaveDialog;
    GroupBox2: TGroupBox;
    Y_list: TListBox;
    GroupBox3: TGroupBox;
    x_List: TListBox;
    GroupBox4: TGroupBox;
    grafic: TImage;
    GroupBox5: TGroupBox;
    imgplus: TImage;
    imgminus: TImage;
    imgopen: TImage;
    Image4: TImage;
    imgkeyboard: TImage;
    GroupX: TGroupBox;
    znX: TEdit;
    GroupY: TGroupBox;
    ZnY: TEdit;
    imgpoint: TImage;
    imgcalc: TImage;
    imgsave: TImage;
    OpenDialog1: TOpenDialog;
    MainMenu2: TMainMenu;
    dsdfas1: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;

    function  DefineArea(X1,Y1,X2,Y2,X3,Y3:real):real;
    function  Determinant(A:matrix3x3):real;
    function  module(x1,y1,x2,y2:real):real;
    function  intriangle(x,y,x1,y1,x2,y2,x3,y3:real):boolean;
    procedure graphic;
    procedure plus(Sender: TObject);
    procedure minus(Sender: TObject);
    procedure closeform(Sender: TObject);
    procedure open(Sender: TObject);
    procedure new(Sender: TObject);
    procedure sortpoints(coord:coords;x,num:integer);
    procedure addpoint(Sender: TObject);
    procedure obrabotka(Sender: TObject);
    procedure raschet;
    procedure savefile(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

const mashtab:integer=20;     // 
      numtriangles:integer=0; //- 
      numpoints:integer=0;    //  
var
  f_name:String;
  tf:System.Text;
  calculate: Tcalculate;
  Massiv_xy: coords; //  
  triarray:array [0..100] of points; //

implementation
{$R *.DFM}
//------------------------------------------------------------------------------
//   3- 
function  Tcalculate.Determinant(A:matrix3x3):real;
begin
  Determinant:=a[1,1]*a[2,2]*a[3,3]-
               a[1,1]*a[2,3]*a[3,2]+
               a[1,2]*a[2,3]*a[3,1]-
               a[1,2]*a[2,1]*a[3,3]+
               a[1,3]*a[2,1]*a[3,2]-
               a[1,3]*a[2,2]*a[3,1]
end;
//------------------------------------------------------------------------------
//     
function Tcalculate.module(x1,y1,x2,y2:real):real;
begin
  module:=sqrt(sqr(x1-x2)+sqr(y1-y2))
end;
//------------------------------------------------------------------------------
//,    (x,y)  
function Tcalculate.intriangle(x,y,x1,y1,x2,y2,x3,y3:real):boolean;
var k1,k2,k3,
    b1,b2,b3:real;
begin
if x2=x1 then k1:=1 else k1:=(y2-y1)/(x2-x1);
if x3=x1 then k2:=1 else k2:=(y3-y1)/(x3-x1);
if x2=x3 then k3:=1 else k3:=(y2-y3)/(x2-x3);
b1:=y1-k1*x1;
b2:=y1-k2*x1;
b3:=y3-k3*x3;
if (y<=k1*x+b1) and (y>=k3*x+b3) and (y<=k2*x+b2) then
   intriangle:=true else intriangle:=false;
end;
//------------------------------------------------------------------------------
//      ( )
function Tcalculate.DefineArea(X1,Y1,X2,Y2,X3,Y3:real):real;
var p:real;
begin
p:=(module(x1,y1,x2,y2)+module(x2,y2,x3,y3)+module(x3,y3,x1,y1))/2;
DefineArea:=sqrt(p*(p-module(x1,y1,x2,y2))*(p-module(x2,y2,x3,y3))*
                (p-module(x3,y3,x1,y1)));
end;
//------------------------------------------------------------------------------
// 
procedure Tcalculate.graphic;
var i:byte;
    triangle:points;
begin
grafic.Canvas.Brush.Color:=clwhite;
grafic.Canvas.pen.Color:=clgray;
grafic.canvas.Rectangle(0,0,grafic.width,grafic.height);
grafic.canvas.MoveTo(round(grafic.width/2),0);
grafic.Canvas.LineTo(round(grafic.width/2),grafic.height);
grafic.canvas.MoveTo(0,round(grafic.height/2));
grafic.Canvas.LineTo(grafic.Width,round(grafic.height/2));
grafic.Canvas.Brush.Color:=clsilver;
grafic.Canvas.pen.Color:=clblack;
for i:=1 to numtriangles do
begin
triangle[1].x:=round(grafic.width/2+triarray[i,1].x*mashtab);
triangle[1].y:=round(grafic.height/2-triarray[i,1].y*mashtab);
triangle[2].x:=round(grafic.width/2+triarray[i,2].x*mashtab);
triangle[2].y:=round(grafic.height/2-triarray[i,2].y*mashtab);
triangle[3].x:=round(grafic.width/2+triarray[i,3].x*mashtab);
triangle[3].y:=round(grafic.height/2-triarray[i,3].y*mashtab);
grafic.Canvas.Polygon(triangle);
end;
end;
//------------------------------------------------------------------------------
// 
procedure Tcalculate.plus(Sender: TObject);
begin
inc(mashtab,3);
graphic
end;
//------------------------------------------------------------------------------
// 
procedure Tcalculate.minus(Sender: TObject);
begin
dec(mashtab,3);
if mashtab<1 then mashtab:=1;
graphic
end;
//------------------------------------------------------------------------------
//   
procedure Tcalculate.sortpoints(coord:coords;x,num:integer);
var i,j,k:integer;
    flag:boolean;
    matrix:matrix3x3;
begin
// 
 k:=0;
 numtriangles:=0;
 coord[numpoints+1].x:=coord[1].x;
 coord[numpoints+1].y:=coord[1].y;
 for i:=1 to 100 do
 begin
     triarray[i,1].x:=0;  triarray[i,1].y:=0;
     triarray[i,2].x:=0;  triarray[i,2].y:=0;
     triarray[i,3].x:=0;  triarray[i,3].y:=0;
 end;
 i:=x;
while num>3 do begin//[0]   

//[4]  
 inc(k);
 if k>sqr(numpoints) then begin
    sortpoints(Massiv_xy,x+1,numpoints); //    
    exit;
 end;
//[4]

if i<num then inc(i) else i:=x;

matrix[1,1]:=coord[i-1].x; matrix[1,2]:=coord[i-1].y; matrix[1,3]:=1;
matrix[2,1]:=coord[i].x;   matrix[2,2]:=coord[i].y;   matrix[2,3]:=1;
matrix[3,1]:=coord[i+1].x; matrix[3,2]:=coord[i+1].y; matrix[3,3]:=1;
if Determinant(matrix)>0 then begin //   [1]
    flag:=true;

// [5]    
for j:=2 to num do if not (j in [i-1..i+1]) and
 intriangle(coord[j].x  , coord[j].y,
            coord[i-1].x, coord[i-1].y,
            coord[i].x  , coord[i].y,
            coord[i+1].x, coord[i+1].y)
    then flag:=false;
// [5]

     if flag then begin //     [2]
     inc(numtriangles);
     triarray[numtriangles,1].x:=coord[i-1].x;
     triarray[numtriangles,1].y:=coord[i-1].y;
     triarray[numtriangles,2].x:=coord[i].x;
     triarray[numtriangles,2].y:=coord[i].y;
     triarray[numtriangles,3].x:=coord[i+1].x;
     triarray[numtriangles,3].y:=coord[i+1].y;
     for j:=i to num do begin //  [3]
                coord[j].x:=coord[j+1].x;
                coord[j].y:=coord[j+1].y;
            end;//[3]
    i:=x;
    dec(num);
    end//[2]
end//[1]
end;//[0]

inc(numtriangles);
triarray[numtriangles,1].x:=coord[1].x; triarray[numtriangles,1].y:=coord[1].y;
triarray[numtriangles,2].x:=coord[2].x; triarray[numtriangles,2].y:=coord[2].y;
triarray[numtriangles,3].x:=coord[3].x; triarray[numtriangles,3].y:=coord[3].y;
end;
//------------------------------------------------------------------------------
//    
procedure Tcalculate.open(Sender: TObject);
begin
If(OpenDialog1.execute) then begin
  f_name:=Opendialog1.FileName;
  if  f_name<>'' then begin
    x_list.Clear;
    y_list.Clear;
    memo1.Clear;
    System.Assign(tf,f_name);
    Reset(tf);
    numpoints:=0;
    While not eof(tf)do begin
        inc(numpoints);
        Readln(tf,Massiv_xy[numpoints].x,Massiv_xy[numpoints].y);
        x_list.Items.Add(intToStr(Massiv_xy[numpoints].x));
        y_list.Items.Add(intToStr(Massiv_xy[numpoints].y));
        end;
    System.Close(tf);
    raschet;
    imgsave.hide;
    label1.hide;
    label2.hide;
    label3.hide;
    end;
  end;
end;
//------------------------------------------------------------------------------
//   
procedure Tcalculate.new(Sender: TObject);
var i:byte;
begin
grafic.hide;
label1.hide;
label2.hide;
label3.hide;
imgplus.hide;
imgminus.hide;
imgpoint.show;
imgcalc.show;
imgkeyboard.hide;
imgopen.hide;
imgsave.hide;
GroupX.show;
GroupY.show;
x_list.Clear;
y_list.Clear;
memo1.Clear;
numpoints:=0;
znX.SetFocus;
for i:=1 to 100 do begin
        Massiv_xy[i].x:=0; Massiv_xy[i].y:=0;
        end;
end;
//------------------------------------------------------------------------------
//  
procedure Tcalculate.addpoint(Sender: TObject);
begin
if (znX.text<>'') and (znY.text<>'') then begin
inc(numpoints);
x_list.Items.Add(znX.text);
y_list.Items.Add(znY.text);
Massiv_xy[numpoints].x:=strtoint(znX.text);
Massiv_xy[numpoints].y:=strtoint(znY.text);
znX.Clear;
znY.Clear;
znX.SetFocus;
end;
end;
//------------------------------------------------------------------------------
// 
procedure Tcalculate.raschet;
var i:byte;
    area:real;
begin
sortpoints(Massiv_xy,2,numpoints);
area:=0;
for i:=1 to numtriangles do
area:=area+DefineArea(triarray[i,1].x,triarray[i,1].y,
                      triarray[i,2].x,triarray[i,2].y,
                      triarray[i,3].x,triarray[i,3].y);
memo1.Lines.Add('   '+floattostr(area));
GroupX.hide;
GroupY.hide;
imgplus.show;
imgkeyboard.show;
imgopen.show;
imgminus.show;
imgpoint.hide;
imgcalc.hide;
grafic.Show;
graphic;
end;
//------------------------------------------------------------------------------
//    
procedure Tcalculate.savefile(Sender: TObject);
var i:byte;
begin
if (numpoints>0)and(SaveDialog1.execute)then
    begin
        f_name:=SaveDialog1.FileName;
        if  f_name<>'' then
        begin
         System.Assign(tf,f_name);
         rewrite(tf);
         for i:=1 to numpoints do
           writeln(tf,inttostr(Massiv_xy[i].x),' ',inttostr(Massiv_xy[i].y));
         System.Close(tf);
    end end;
imgsave.hide;
end;
//------------------------------------------------------------------------------
procedure Tcalculate.obrabotka(Sender: TObject);
begin
if numpoints>0 then imgsave.show;
raschet
end;

procedure Tcalculate.closeform(Sender: TObject);
begin Close end;

end.
